#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>

typedef long long llong;
const int MAXN = 10000000 + 10;
const int INF  = 1e9;

int n;
llong k;
int a[MAXN];
int x, y, z, m;

llong check(int l, int r)
{
    llong max = 0;
    for (int split = l ; split <= r ; ++split)
    {
        llong left = 0, right = 0;
        for (int i = l ; i <= split ; ++i)
        {
            left += a[i];
        }

        for (int i = split + 1 ; i <= r ; ++i)
        {
            right += a[i];
        }

        max = std::max(max, std::min(left, right));
    }

    return max;
}

void solve()
{
    if (k == 0)
    {
        std::cout << 1LL * n * (n + 1) / 2 << '\n';
        return;
    }
    
    int ans = 0;
    for (int l = 1 ; l <= n ; ++l)
    {
        if (check(l, l + 1) >= k)
        {
            ans += n - l;
            continue;
        }

        for (int r = n ; r >= l ; --r)
        {
            if (check(l, r) >= k)
            {
                ans++;
            } else
            {
                break;
            }
        }
    }

    std::cout << ans << '\n';
}

void input()
{
    std::cin >> n >> k;
    std::cin >> a[1] >> a[2] >> x >> y >> z >> m;
    for (int i = 3 ; i <= n ; ++i)
    {
        a[i] = (1LL * a[i - 2] * x + 1LL * a[i - 1] * y + z) % m;
    }
}

void fastIO()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIO();
    input();
    solve();

    return 0;
}