#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>

typedef long long llong;
const int MAXN = 10000000 + 10;
const int INF  = 1e9;

int n;
llong k;
int a[MAXN];
llong prefix[MAXN];
int x, y, z, m;

llong calcSum(int l, int r)
{
    return prefix[r] - prefix[l - 1];
}

int ptr;
llong check(int l, int r)
{
    if (l == r)
    {
        return 0;
    }

    if (l + 1 == r)
    {
        return std::min(a[l], a[r]);
    }

    ptr = std::max(ptr, l);
    while (ptr + 2 <= r && calcSum(l, ptr + 1) <= calcSum(ptr + 2, r))
    {
        ptr++;
    }

    return std::max(calcSum(l, ptr), calcSum(ptr + 2, r));
}

void solve()
{
    for (int i = 1 ; i <= n ; ++i)
    {
        prefix[i] = prefix[i - 1] + a[i];
    }

    int lPtr = 0;
    llong ans = 0;
    for (int rPtr = 1 ; rPtr <= n ; rPtr++)
    {
        while (lPtr + 1 <= rPtr && check(lPtr + 1, rPtr) >= k)
        {
            lPtr++;
        }

        ans += lPtr;
    }

    std::cout << ans << '\n';
}

void input()
{
    std::cin >> n >> k;
    std::cin >> a[1] >> a[2] >> x >> y >> z >> m;
    for (int i = 3 ; i <= n ; ++i)
    {
        a[i] = (1LL * a[i - 2] * x + 1LL * a[i - 1] * y + z) % m;
    }
}

void fastIO()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIO();
    input();
    solve();

    return 0;
}