#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>

typedef long long llong;
const int MAXN = 10000000 + 10;
const int INF  = 1e9;

int n;
llong k;
int a[MAXN];
llong prefix[MAXN];
int x, y, z, m;

llong calcSum(int l, int r)
{
    return prefix[r] - prefix[l - 1];
}

void solve()
{
    for (int i = 1 ; i <= n ; ++i)
    {
        prefix[i] = prefix[i - 1] + a[i];
    }

    int ans = 0, ptr;
    for (int l = 1 ; l <= n ; ++l)
    {
        ptr = l;
        ans += (k == 0);
        if (l < n)
        {
            ans += (std::min(a[l], a[l + 1]) >= k);
        }
        
        for (int r = l + 2 ; r <= n ; ++r)
        {
            while (ptr + 2 <= r && calcSum(l, ptr + 1) <= calcSum(ptr + 2, r))
            {
                ptr++;
            }

            if (std::max(calcSum(l, ptr), calcSum(ptr + 2, r)) >= k)
            {
                ans++;
            }
        }
    }

    std::cout << ans << '\n';
}

void input()
{
    std::cin >> n >> k;
    std::cin >> a[1] >> a[2] >> x >> y >> z >> m;
    for (int i = 3 ; i <= n ; ++i)
    {
        a[i] = (1LL * a[i - 2] * x + 1LL * a[i - 1] * y + z) % m;
    }
}

void fastIO()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIO();
    input();
    solve();

    return 0;
}